package ap.proof.goal;

import ap.basetypes.HeapCollector
import ap.terfor.ConstantTerm

object TaskInfoCollector {
  
  val EMPTY : TaskInfoCollector = new TaskInfoCollector(Set.empty)
  
}

class TaskInfoCollector private (val constants : Set[ConstantTerm])
      extends HeapCollector[Task, TaskInfoCollector] {

  def +(task : Task, otherInfos : TaskInfoCollector) : TaskInfoCollector = {
    val taskConstants = task match {
                          case task : FormulaTask => task.formula.constants
                          case _ => Set.empty 
                        }
    new TaskInfoCollector(this.constants ++ taskConstants ++ otherInfos.constants)
  }
  
}
